public class StringReadist extends AbstractReadist {
    private String str;
    private int k;
    /** A Reader delivering the characters in STR. */
    public StringReadist(String str)
    { this.str = str; k = 0; }
    
    public void close() { str = null; }

    public int read(char[] buf, int off, int len) {
        if (k == str.length())
            return -1;
        len = Math.min(len, str.length() - k);
        str.getChars(k, k+len, buf, off);
        k += len;
        return len;
    }

    /** The total number of words in R, where a "word" is
    * a maximal sequence of non-whitespace characters. */
    int wc(Readist r) {
        int c0, count;
        c0 = ' '; count = 0;
        while (true) {
            int c = r.read();
            if (c == -1) return count;
            if (Character.isWhitespace((char) c0) && 
                ! Character.isWhitespace((char) c))
                count += 1;
            c0 = c;
        }
    }

}
